    PROGRAM nag_lin_lsq_ex09

      ! Example Program Text for nag_lin_lsq
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_lin_lsq, ONLY : nag_qr_fac, nag_lin_lsq_sol_qr
      USE nag_write_mat, ONLY : nag_write_gen_mat
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND, MIN
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, m, n, nrhs, ns
      ! .. Local Arrays ..
      INTEGER, ALLOCATABLE :: pivot(:)
      REAL (wp), ALLOCATABLE :: std_err(:)
      COMPLEX (wp), ALLOCATABLE :: a(:,:), b(:,:), tau(:), x(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_lin_lsq_ex09'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) m, n, nrhs
      ns = MIN(m,n)

      ALLOCATE (pivot(n),a(m,n),b(m,nrhs),tau(ns),std_err(nrhs), &
       x(n,nrhs))                          ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,m)
      READ (nag_std_in,*) (b(i,:),i=1,m)

      ! Compute the QR factorization
      pivot = 0

      CALL nag_qr_fac(a,tau,pivot=pivot)

      ! Compute the minimum norm solution

      CALL nag_lin_lsq_sol_qr(a,tau,b,x,pivot=pivot,std_err=std_err)

      WRITE (nag_std_out,*)

      CALL nag_write_gen_mat(x,int_col_labels=.TRUE.,format='(F7.4)', &
       title='Minimum norm solutions (one solution per column)')

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) ' Standard errors'
      WRITE (nag_std_out,'(11X,4(F8.4:,10X))') std_err

      DEALLOCATE (pivot,a,b,tau,std_err,x) ! Deallocate storage

    END PROGRAM nag_lin_lsq_ex09
